\section{Experiments and Results}\label{s:experiment}

This section presents the evaluation of the proposed approach, described in the previous section~\ref{s:approach}. Particularly, its objective is to answer the research question:

\textbf{[RQ]: Can personalisation approaches yield similar quality suggestions to customisation systems for \emph{question-and-answer-sites}?}

The research question helps to determine if a rather open-domain platform like the \ac{qna} platform of \icite{so.2019}, could be improved by introducing recommender systems into the process of finding questions to answer. By extension this shows that recommender systems are helping to improve the user experience as a side-effect of reducing the effort the user's have to expend to find questions they are able to answer.

\subsection{Experimental Setup}

The development, the training of the models and the execution of the experiment was done on the device specified in table~\ref{t:device:configuration}.

\tabenv[
    label=t:device:configuration,
    caption=Device used to conduct the experiment.
]{ll}
{
\toprule
\multicolumn{2}{c}{\textbf{Device Configuration}} \\
\midrule
Manufacturer & Apple \\
Device & MacBook Pro (Retina, 15-inch, Mid 2014) \\
Processor & Quad-Core Intel Core i7 @ 2,8 GHz \\
Memory & 16 GB 1600 MHz DDR3 \\
Operating System & macOS Catalina 10.15.1 \\
\bottomrule
}

\subsection{Experimental Scenarios}

To verify if the models that are generated from the extracted subset perform accurately, a self-ranking test is performed. For which every item in the test set is compared to every item the model was trained on. Thereafter the results are ranked by similarity and it is tested if the items rank best against themselves.

Furthermore for every combination of recommender and text-model a confusion matrix is generated, that will be used to obtain the performance measures for the recommendations. In this process, the top-10 similar entities (either items or user) are used for every recommendation. Over the course of all the recommendations statistical aggregates of min, max, mean, median, standard deviation and variance are generated for the performance measures. Furthermore the performance measures are binned together in histogram-plots and a normal distribution plot is generated for better interpretability. The process is depicted in figure~\ref{fig:test}.

\image[
    label=fig:test,
    caption=Activity diagram of the test setup used for the self-ranking and the performance test.,
    width=0.6\textwidth
]{images/test_recommender.png}

\subsection{Results}

In the self-ranking tests, every text-model performed at around $95\%$ accuracy. The plots are added in \ref{ss:appendixb}.

The recommender names are a combination of the approach used, thus \emph{questions-answered-by-similar-users.questions-doc2vec-pv-dbow} refers to the \emph{questions-answered-by-similar-users} recommender, with the \emph{doc2vec-pv-dbow} text model on all the \emph{questions}. The schema is therefore the following: \emph{<recommender-name>.<dataset>-<text-model>}.

\subsubsection{Similar Questions}

The \emph{similar-questions} recommender, performed the same regardless of the text-model used or the data the model was trained on, i.e. questions and answers respectively. The retrieved statistical information is displayed in figure~\ref{fig:similar:questions:stats}.

\image[
    label=fig:similar:questions:stats,
    caption={The statistical date of the performance measures for the \emph{similar-questions.answers-doc2vec-pv-dbow} recommender.}
]{"images/data/similar-questions.answers-doc2vec-pv-dbow/confusion-matrix-stats".png}

The \emph{accuracy} of this algorithm reaches on average $99\%$, which is very high. The reason therefore is, that this algorithm does not recommend many \acp{fp}. This can be confirmed when looking at the \emph{precision}, that is very well for a few cases (\emph{max $100\%$}) and fails completely for others (\emph{min $0\%$}). This is clear when looking at the data. Many users have not even asked any questions. For these no recommendations can be generated by this recommender. It is even more overt, when looking at the histogram of figure~\ref{fig:sq:prec}. The \emph{recall} is always at $100\%$, this is apparent from the statistical data, which could either mean, that \acp{tp} and \acp{fn} were always both $0$ because this is a special case in which the \emph{recall} is $100\%$, or that in the cases in which the algorithm returned recommendations, always all the recommendations match the \emph{ground truth}, which is very unlikely. It is more likely that the \emph{precision} is also performing well because of the special case, in which it returns $100\%$, when both \acp{tp} and \acp{fp} are $0$. This falsifies \textbf{[Hypothesis 1]}. 

\doubleimage[
    caption={Precision and recall histogram of the \emph{similar-questions.answers-doc2vec-pv-dbow} recommender.},
    captiona="Precision",
    captionb="Recall",
    label=fig:sq:prec:rec,
    labela=fig:sq:prec,
    labelb=fig:sq:rec
]
{"images/data/similar-questions.answers-doc2vec-pv-dbow/images/10-precision".png}
{"images/data/similar-questions.answers-doc2vec-pv-dbow/images/10-recall".png}

\doubleimage[
    caption={Accuracy and F1-Measure histogram of the \emph{similar-questions.answers-doc2vec-pv-dbow} recommender},
    captiona="Accuracy",
    captionb="F1-Measure",
    label=fig:sq:d2v:dm:a
]
{"images/data/similar-questions.answers-doc2vec-pv-dbow/images/10-accuracy".png}
{"images/data/similar-questions.answers-doc2vec-pv-dbow/images/10-f-measure".png}

\doubleimage[
    caption={Precision and recall normal distribution plot for the \emph{similar-questions.answers-doc2vec-pv-dbow} recommender.},
    captiona="Precision",
    captionb="Recall",
    label=fig:sq:b:s
]
{"images/data/similar-questions.answers-doc2vec-pv-dbow/images/10-precision-stats".png}
{"images/data/similar-questions.answers-doc2vec-pv-dbow/images/10-recall-stats".png}

\doubleimage[
    caption={Accuracy and F1-Measure normal distribution plot for the \emph{similar-questions.answers-doc2vec-pv-dbow} recommender.},
    captiona="Accuracy",
    captionb="f1-Measure",
    label=fig:sq:a:s
]
{"images/data/similar-questions.answers-doc2vec-pv-dbow/images/10-accuracy-stats".png}
{"images/data/similar-questions.answers-doc2vec-pv-dbow/images/10-f-measure-stats".png}

\subsubsection{Questions of Similar Users}

Again the \emph{accuracy} is at $99\%$ for all the different combinations of text-models and data used. \emph{Recall} and \emph{precision}, likewise are either $0\%$ or $100\%$ because no recommendations could be found. The reason therefore most likely is that the data is very sparse and also that the dataset was too small. Even if users are similar, they may never search for the same questions or come across the same problems. This likewise falsifies \textbf{[Hypothesis 2]}. The concrete results of one particular experiment can be seen in figure~\ref{fig:question:similar:user:stats}.

\image[
    label=fig:question:similar:user:stats,
    caption={The statistical date of the performance measures for the \emph{questions-by-similar-users.questions-tfidf-ntc} recommender with the \ac{tfidf} text-model on the questions.}
]{"images/data/questions-by-similar-users.questions-tfidf-ntc/confusion-matrix-stats".png}

\doubleimage[
    caption={Precision and recall histogram of the \emph{questions-by-similar-users.questions-tfidf-ntc} recommender.},
    captiona="Precision",
    captionb="Recall",
    label=fig:qosu:prec:rec,
    labela=fig:qosu:prec,
    labelb=fig:qosu:rec
]
{"images/data/questions-by-similar-users.questions-tfidf-ntc/images/10-precision".png}
{"images/data/questions-by-similar-users.questions-tfidf-ntc/images/10-recall".png}

\doubleimage[
    caption={Accuracy and F1-Measure histogram of the \emph{questions-by-similar-users.questions-tfidf-ntc} recommender},
    captiona="Accuracy",
    captionb="F1-Measure",
    label=fig:qosu:d2v:dm:a
]
{"images/data/questions-by-similar-users.questions-tfidf-ntc/images/10-accuracy".png}
{"images/data/questions-by-similar-users.questions-tfidf-ntc/images/10-f-measure".png}

\doubleimage[
    caption={Precision and recall normal distribution plot for the \emph{questions-by-similar-users.questions-tfidf-ntc} recommender.},
    captiona="Precision",
    captionb="Recall",
    label=fig:qosu:b:s
]
{"images/data/questions-by-similar-users.questions-tfidf-ntc/images/10-precision-stats".png}
{"images/data/questions-by-similar-users.questions-tfidf-ntc/images/10-recall-stats".png}

\doubleimage[
    caption={Accuracy and F1-Measure normal distribution plot for the \emph{questions-by-similar-users.questions-tfidf-ntc} recommender.},
    captiona="Accuracy",
    captionb="f1-Measure",
    label=fig:qosu:a:s
]
{"images/data/questions-by-similar-users.questions-tfidf-ntc/images/10-accuracy-stats".png}
{"images/data/questions-by-similar-users.questions-tfidf-ntc/images/10-f-measure-stats".png}

\subsubsection{Questions Answered by Similar Users}

The last recommender yields the same results as the ones before. High accuracy bad precision and recall. This again falsifies \textbf{[Hypothesis 3]}. The statistical information can be seen in figure~\ref{fig:question:answered:similar:user:stats}.

\image[
    label=fig:question:answered:similar:user:stats,
    caption={The statistical date of the performance measures for the \emph{questions-answered-by-similar-users.questions-lda-standard} recommender with the \ac{lda} text-model on the questions.}
]{"images/data/questions-answered-by-similar-users.questions-lda-standard/confusion-matrix-stats".png}

\doubleimage[
    caption={Precision and recall histogram of the \emph{questions-answered-by-similar-users.questions-lda-standard} recommender.},
    captiona="Precision",
    captionb="Recall",
    label=fig:qasu:prec:rec,
    labela=fig:qasu:prec,
    labelb=fig:qasu:rec
]
{"images/data/questions-answered-by-similar-users.questions-lda-standard/images/10-precision".png}
{"images/data/questions-answered-by-similar-users.questions-lda-standard/images/10-recall".png}

\doubleimage[
    caption={Accuracy and F1-Measure histogram of the \emph{questions-answered-by-similar-users.questions-lda-standard} recommender},
    captiona="Accuracy",
    captionb="F1-Measure",
    label=fig:qasu:a:s
]
{"images/data/questions-answered-by-similar-users.questions-lda-standard/images/10-accuracy".png}
{"images/data/questions-answered-by-similar-users.questions-lda-standard/images/10-f-measure".png}

\doubleimage[
    caption={Precision and recall normal distribution plot for the \emph{questions-answered-by-similar-users.questions-lda-standard} recommender.},
    captiona="Precision",
    captionb="Recall",
    label=fig:qasu:b:s
]
{"images/data/questions-answered-by-similar-users.questions-lda-standard/images/10-precision-stats".png}
{"images/data/questions-answered-by-similar-users.questions-lda-standard/images/10-recall-stats".png}

\doubleimage[
    caption={Accuracy and F1-Measure normal distribution plot for the \emph{questions-answered-by-similar-users.questions-lda-standard} recommender.},
    captiona="Accuracy",
    captionb="f1-Measure",
    label=fig:qasu:a:s
]
{"images/data/questions-answered-by-similar-users.questions-lda-standard/images/10-accuracy-stats".png}
{"images/data/questions-answered-by-similar-users.questions-lda-standard/images/10-f-measure-stats".png}

